// KSymView.cpp : implementation of the CKSymView class
//

#include "stdafx.h"
#include "KSym.h"

#include "KSymDoc.h"
#include "KSymView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CKSymView

IMPLEMENT_DYNCREATE(CKSymView, CView)

BEGIN_MESSAGE_MAP(CKSymView, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
    ON_WM_CHAR()
    ON_WM_KEYDOWN()
    ON_WM_SYSCHAR()
    ON_WM_DEADCHAR()
    ON_WM_PAINT()
END_MESSAGE_MAP()

// CKSymView construction/destruction

CKSymView::CKSymView():
    m_nChar(0),
    m_nRepCnt(0),
    m_nFlags(0),
    m_KeyChar(0),
    m_KeyRepCnt(0),
    m_KeyFlags(0),
    m_SysChar(0),
    m_SysRepCnt(0),
    m_SysFlags(0),
    m_Message(0),
    m_wParam(0),
    m_lParam(0),
    m_ShiftState(FALSE),
    m_ControlState(FALSE),
    m_AltState(FALSE)
{
	// TODO: add construction code here
    ((CKSymApp*) AfxGetApp())->m_pView = this; 
}

CKSymView::~CKSymView()
{
    ((CKSymApp*) AfxGetApp())->m_pView = NULL;
}

BOOL CKSymView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CKSymView drawing

void CKSymView::OnDraw(CDC* pDC)
{
	CKSymDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: add draw code for native data here
    int x = 4, y = 4;
    TCHAR line[256];
    _stprintf_s(
        line, 256,
        _T("OnChar: nChar=0x%X  nFlags=0x%X   character: %c"),
        m_nChar, m_nFlags, m_nChar
    );
    line[255] = 0;
    size_t len = _tcslen(line);
    
    CSize s = pDC->GetTextExtent(line, len);
    if (m_nChar != 0)
        pDC->TextOut(x, y, line, len); 
    y += s.cy + 4;

    _stprintf_s(
        line, 256,
        _T("OnKeyDown: nChar=0x%X  nFlags=0x%X   character: %c"),
        m_KeyChar, m_KeyFlags, m_KeyChar
    );
    line[255] = 0;
    
    len = _tcslen(line);
    s = pDC->GetTextExtent(line, len);
    //... if (m_KeyChar != 0)
    pDC->TextOut(x, y, line, len); 
    y += s.cy + 4;

    _stprintf_s(
        line, 256,
        _T("OnSysChar: nChar=0x%X  nFlags=0x%X   character: %c"),
        m_SysChar, m_SysFlags, m_SysChar
    );
    line[255] = 0;
    
    len = _tcslen(line);
    //... if (m_KeyChar != 0)
    s = pDC->GetTextExtent(line, len);
    pDC->TextOut(x, y, line, len); 
    y += s.cy + 4;

    if (m_Message != 0)
    {
        _stprintf_s(
            line, 256,
            _T("PreTranslateMessage: message=0x%X  wParam=0x%X   lParam=0x%X"),
            m_Message, m_wParam, m_lParam
        );
        line[255] = 0;
        //... len = _tcslen(line);

        CString str = line;
        if (m_ShiftState)
            str += _T(" Shift");
        if (m_ControlState)
            str += _T(" Control");
        if (m_AltState)
            str += _T(" Alt");
        len = str.GetLength();
            
        //... s = pDC->GetTextExtent(line, len);
        //... pDC->TextOut(x, y, line, len); 
        s = pDC->GetTextExtent(str, len);
        pDC->TextOut(x, y, str, len); 
        y += s.cy + 4;
    }    
}

// CKSymView printing

BOOL CKSymView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CKSymView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CKSymView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CKSymView diagnostics

#ifdef _DEBUG
void CKSymView::AssertValid() const
{
	CView::AssertValid();
}

void CKSymView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CKSymDoc* CKSymView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CKSymDoc)));
	return (CKSymDoc*)m_pDocument;
}
#endif //_DEBUG


// CKSymView message handlers

void CKSymView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
    // TODO: Add your message handler code here and/or call default
    m_nChar = nChar;
    m_nRepCnt = nRepCnt;
    m_nFlags = nFlags;
    Invalidate();    

    CView::OnChar(nChar, nRepCnt, nFlags);
}

void CKSymView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
    // TODO: Add your message handler code here and/or call default
    m_KeyChar = nChar;
    m_KeyRepCnt = nRepCnt;
    m_KeyFlags = nFlags;
    Invalidate();

    CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CKSymView::OnSysChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
    // TODO: Add your message handler code here and/or call default
    m_SysChar = nChar;
    m_SysRepCnt = nRepCnt;
    m_SysFlags = nFlags;
    Invalidate();

    CView::OnSysChar(nChar, nRepCnt, nFlags);
}

void CKSymView::OnDeadChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
    // TODO: Add your message handler code here and/or call default

    CView::OnDeadChar(nChar, nRepCnt, nFlags);
}

void CKSymView::OnPaint()
{
    CPaintDC dc(this); // device context for painting
    // TODO: Add your message handler code here
    // Do not call CView::OnPaint() for painting messages
    OnDraw(&dc);
}
