// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "TEdit.h"
#include "MainFrm.h"
#include "TEView.h"
#include "TEDoc.h"
#include "SaveQDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
    ON_WM_CREATE()
    ON_UPDATE_COMMAND_UI(ID_INDICATOR_MESSAGE, OnUpdateMessage)
    ON_UPDATE_COMMAND_UI(ID_INDICATOR_LINE, OnUpdateLine)
    ON_UPDATE_COMMAND_UI(ID_INDICATOR_COL, OnUpdateCol)
    ON_WM_CLOSE()
END_MESSAGE_MAP()

static UINT indicators[] =
{
    ID_SEPARATOR,
    ID_INDICATOR_MESSAGE,       // status line indicator
    ID_INDICATOR_LINE,
    ID_INDICATOR_COL,
    ID_INDICATOR_CAPS,
    ID_INDICATOR_NUM,
    ID_INDICATOR_SCRL
};

// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
    // TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
    if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
        return -1;

    if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
        | CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
        !m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
    {
        TRACE0("Failed to create toolbar\n");
        return -1;      // fail to create
    }

    if (!m_wndStatusBar.Create(this) ||
        !m_wndStatusBar.SetIndicators(indicators,
          sizeof(indicators)/sizeof(UINT)))
    {
        TRACE0("Failed to create status bar\n");
        return -1;      // fail to create
    }

    // TODO: Delete these three lines if you don't want the toolbar to be dockable
    m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
    EnableDocking(CBRS_ALIGN_ANY);
    DockControlBar(&m_wndToolBar);

    return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
    if( !CFrameWnd::PreCreateWindow(cs) )
        return FALSE;
    // TODO: Modify the Window class or styles here by modifying
    //  the CREATESTRUCT cs

    return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
    CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
    CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers
void CMainFrame::OnUpdateLine(CCmdUI *pCmdUI)
{
    pCmdUI->Enable();
    CTEditView* pView = (CTEditView*) GetActiveView();
    if (pView != NULL)
    {
        CTEditDoc* pDoc = pView->GetDocument();
        if (pDoc != NULL)
        {
            int n = pView->cursorY + 1;
            wchar_t str[64];
            swprintf_s(
                str, 64,
                _T("Line %d / %d"),
                n, pDoc->text.size()
            );
            pCmdUI->SetText(str);
            //... SetWindowText(pDoc->filePath);
        }
    }
}

void CMainFrame::OnUpdateCol(CCmdUI *pCmdUI)
{
    pCmdUI->Enable();
    CTEditView* pView = (CTEditView*) GetActiveView();
    if (pView != NULL)
    {
        CTEditDoc* pDoc = pView->GetDocument();
        if (pDoc != NULL)
        {
            int n = pView->cursorX + 1;
            wchar_t str[64];
            swprintf_s(
                str, 64,
                _T("Col %d"),
                n
            );
            pCmdUI->SetText(str);
            //... SetWindowText(pDoc->filePath);
        }
    }
}

void CMainFrame::OnUpdateMessage(CCmdUI *pCmdUI)
{
    pCmdUI->Enable();
    CTEditView* pView = (CTEditView*) GetActiveView();
    if (pView != NULL)
    {
        CTEditDoc* pDoc = pView->GetDocument();
        if (pDoc == NULL)
            return;
        LPCTSTR message = _T("");
        if (pDoc->textChanged)
            message = _T("Changed");
        else if (pDoc->textSaved)
            message = _T("Saved");
        pCmdUI->SetText(message);
    }
    //... SetMessageText(_T("Edit a text."));
}

void CMainFrame::OnClose()
{
    // TODO: Add your message handler code here and/or call default
    CTEditView* pView = (CTEditView*) GetActiveView();
    if (pView != NULL)
    {
        CTEditDoc* pDoc = pView->GetDocument();
        if (pDoc != NULL && pDoc->textChanged)
        {
            CSaveQueryDlg saveDlg;
            UINT res = saveDlg.DoModal();
            if (res == IDOK)
            {
                pView->OnFileSave();
            }
            else if (res == IDCANCEL)
                return;
        }
    }

    CFrameWnd::OnClose();
}
