// TEDoc.cpp : implementation of the CTEditDoc class
//

#include "stdafx.h"
#include "TEdit.h"
#include "TEDoc.h"
#include "TEView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTEditDoc

IMPLEMENT_DYNCREATE(CTEditDoc, CDocument)

BEGIN_MESSAGE_MAP(CTEditDoc, CDocument)
END_MESSAGE_MAP()


// CTEditDoc construction/destruction

CTEditDoc::CTEditDoc():
    text(),
    codepage(CP_CYRILLIC_WINDOWS),
    outputCodepage(CP_CYRILLIC_WINDOWS),
    textChanged(false),
    filePathSet(false),
    textSaved(false),
    filePath(_T("")),
    fileDirectory(_T("")),
    fileName(_T(""))
{
    // TODO: add one-time construction code here

}

CTEditDoc::~CTEditDoc()
{
}

BOOL CTEditDoc::OnNewDocument()
{
    if (!CDocument::OnNewDocument())
        return FALSE;

    // TODO: add reinitialization code here
    // (SDI documents will reuse this document)
    text.clear();
    textChanged = false;
    filePathSet = false;
    textSaved = false;
    filePath = "";
    fileDirectory = "";
    fileName = "";

    SetTitle(_T("Noname"));

    return TRUE;
}

// CTEditDoc serialization

void CTEditDoc::Serialize(CArchive& ar)
{
    if (ar.IsStoring())
    {
        // TODO: add storing code here
        if (text.save(ar.GetFile()))
        {
            textChanged = FALSE;
            textSaved = TRUE;
        }
    }
    else
    {
        // TODO: add loading code here
        if (text.load(ar.GetFile()))
        {
            textChanged = FALSE;
            textSaved = FALSE;
            SetFilePath(ar.m_strFileName);
            SetTitle(ar.m_strFileName);

            /*...
            // Find a view
            CTEditView* pView = NULL;
            POSITION pos = GetFirstViewPosition();
            if (pos != NULL)
            {
                pView = (CTEditView*) GetNextView(pos); // The first view
            }
            if (pView != NULL)
            {
                CMainFrame* pFrame =
                    (CMainFrame*)(pView->GetParent());
                pFrame->SetWindowText(ar.m_strFileName);
            }
            ...*/
        }
    }
}


// CTEditDoc diagnostics

#ifdef _DEBUG
void CTEditDoc::AssertValid() const
{
    CDocument::AssertValid();
}

void CTEditDoc::Dump(CDumpContext& dc) const
{
    CDocument::Dump(dc);
}
#endif //_DEBUG


// CTEditDoc commands
void CTEditDoc::SetFilePath(LPCTSTR path)
{
    filePath = path;
    fileDirectory = _T("");
    fileName = _T("");
    LPCTSTR p = path + _tcslen(path);
    while (
        p > path &&
        (*(p-1) != _T('\\') && *(p-1) != _T('/'))
    )
        --p;
    if (
        p > path &&
        (*(p-1) == _T('\\') || *(p-1) == _T('/'))
    )
    {
        size_t dirLen = p - path;
        fileDirectory = CString(path, dirLen);
        fileName = p;
    }
    else
    {
        fileName = path;
    }
    filePathSet = true;
}
