// TEDoc.h : interface of the CTEditDoc class
//


#pragma once

#include "Text.h"

// Character encodings
const UINT CP_CYRILLIC_WINDOWS = 1251;
const UINT CP_WESTERN_WINDOWS = 1252;
const UINT CP_CYRILLIC_KOI8R = 20866;
const UINT CP_CYRILLIC_DOS = 866;

class CTEditDoc : public CDocument
{
protected: // create from serialization only
    CTEditDoc();
    DECLARE_DYNCREATE(CTEditDoc)

// Attributes
public:
    Text text;
    UINT codepage;
    UINT outputCodepage;
    bool textChanged;
    bool filePathSet;
    bool textSaved;
    CString filePath;
    CString fileDirectory;
    CString fileName;

// Operations
public:
    void SetFilePath(LPCTSTR path);

// Overrides
public:
    virtual BOOL OnNewDocument();
    virtual void Serialize(CArchive& ar);

// Implementation
public:
    virtual ~CTEditDoc();
#ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
};


